# -*- coding: utf-8 -*
from __future__ import division
import numpy as np 
import argparse
import time
import cv2
import mahotas

def LabelDetect(HSVframe,grayframe,chans,mask,dilate_kernel,shadow_kernel ,imshow = 1):
	# 下面内容先comment out 为了提高速度

	# 1 确认 Valve 区域
	# valve_h_Lower = np.array([15,31,0])
	# valve_h_Upper = np.array([25,256,256])
	# valveframe = cv2.inRange(HSVframe,valve_h_Lower, valve_h_Upper)
	# # 2 反转 valve 区域
	# dilated = cv2.dilate(valveframe,dilate_kernel)
	# dilatednot = cv2.bitwise_not(dilated)
	# 3 闭运算，计算阴影模式
	# 必须用 grayframe 而不是 chans[2] 否则 detection 会出问题，花白
	closed = cv2.morphologyEx(grayframe, cv2.MORPH_CLOSE,shadow_kernel)	
	# opened = cv2.morphologyEx(grayframe, cv2.MORPH_OPEN,shadow_kernel)	
	# 4 opencv图像矩阵相减，去除光照不均匀形成的阴影对label识别的干扰
	removeshadow = cv2.subtract(closed,chans[2])
	# 5 移除边缘
	removeshadowcut = cv2.bitwise_and(removeshadow,removeshadow,mask = mask)
	# 6 拉伸一下灰度，可以让处于阴影处的字符再亮一点（去除边缘后，label字体亮度更高）
	equal_imgcut = cv2.equalizeHist(removeshadowcut)
	# 7 blur 图像
	ll = 47
	blur = cv2.GaussianBlur(equal_imgcut,(ll,ll),0)
	# 8 大津算法，自适应调整threshold
	T1 = mahotas.thresholding.otsu(blur)
	thresh = blur.copy()
	thresh[thresh > T1] = 255
	thresh[thresh < 255] = 0
	# 9 备用
	label11 = cv2.bitwise_and(equal_imgcut,equal_imgcut,mask = thresh)
	# 10 findContours
	(_,lcnts,_) = cv2.findContours(thresh.copy(),cv2.RETR_EXTERNAL,cv2.CHAIN_APPROX_NONE)#SIMPLE)
	
	
	# # 用来比较的，后期可以删掉
	# if len(lcnts) >0:
	# 	# pointlist = []
	# 	for i in range(len(lcnts)):
	# 		k = cv2.minAreaRect(lcnts[i])
			# print("k",k)
	# 		kx = k[1][0]
	# 		ky = k[1][1]
	# 		print("kx",kx,"ky",ky)
	# 		area = kx*ky
	# 		print("area",area)
	# 		# k1 = (int(k[0][0]),int(k[0][1]))
	# 		# k2 = (int(k[1][0]),int(k[1][1]))
	# 		kr1 = kx/(ky+0.01)
	# 		kr2 = ky/(kx+0.01)
	# 		if 600<area<4500:
	# 			rect = np.int32(cv2.boxPoints(cv2.minAreaRect(lcnts[i])))
	# 			# print("rect",rect)
	# 			cv2.drawContours(valveframe, [rect],-1,(0,0,255),1)
	# 		# if kx>ky and 1.4<=kr1<=3.2:
	# 		# 	rect = np.int32(cv2.boxPoints(cv2.minAreaRect(lcnts[i])))
	# 		# 	print("rect",rect)
	# 		# 	cv2.drawContours(label11, [rect],-1,(255,255,255),1)
	# 		# elif kx<ky and 1.4<=kr2<=3.2:
	# 		# 	rect = np.int32(cv2.boxPoints(cv2.minAreaRect(lcnts[i])))
	# 		# 	cv2.drawContours(label11, [rect],-1,(255,255,255),1)
	# 		# 	print("rect",rect)
	# 		# else:
	# 		# 	continue


	if imshow == 1:
		# cv2.imshow("1 valveframe",valveframe)
		# cv2.imshow("2 Dilate Inverse",dilatednot)
		cv2.imshow("3 Close operation",closed)
		# cv2.imshow("4 Open operation",opened)
		# cv2.imshow("4 OpenCV subtract",removeshadow)
		cv2.imshow("5 removecut",removeshadowcut)
		cv2.imshow("6 clahe cut",equal_imgcut)
		# cv2.imshow("7 GaussianBlur",blur)
		cv2.imshow("8 Ostu's thresh",thresh)
		# cv2.imshow("9 label11",label11)
		cv2.imshow("10 label segmentation",label11)



	# # 第六步换做用大津算法，可以去除一部分的非 label 信息干扰，但是也会牺牲掉一部分的 label， 尤其是远处的label 和 光照不足处的 label
	# # 5
	# (ret,th) = cv2.threshold(removeshadowcut,0,255,cv2.THRESH_BINARY+cv2.THRESH_OTSU)
	# cv2.imshow("th",th)
	# # 6
	# equal_imgcutt = cv2.equalizeHist(th)

	return lcnts