 # -*- coding: utf-8 -*
from __future__ import division
import numpy as np 
import argparse
import time
import cv2
import matplotlib.pyplot as plt
# 用来备注文字
from PIL import Image  
from PIL import ImageDraw  
from PIL import ImageFont

# new package
import creat
# import camera_trackingnew
import Intervention
import edge_detect
import visual_guidance

# 还没想好怎么解决这个问题
# import UDP

# 读取视频
ap = argparse.ArgumentParser()
ap.add_argument("-v", "--video",
	help = "path to the (optional) video file")
args = vars(ap.parse_args())
camera = cv2.VideoCapture(args["video"])
v = args["video"]

# 图像预处理
def image_preprocessing(frame):
	HSVframe = cv2.cvtColor(frame, cv2.COLOR_BGR2HSV)
	chans = cv2.split(HSVframe)#
	grayframe = cv2.cvtColor(frame, cv2.COLOR_BGR2GRAY)
	(r,c,k)= frame.shape
	return chans,grayframe,r,c
# 移除 frame 中的干扰内容： Label
def label_remove_ll(chans,m,n,imshow = 0):
	# 黄色 label  白色 label
	im_yellow = cv2.subtract(chans[1],chans[0])
	im_white = cv2.subtract(chans[2],chans[1])
	# 所有 label
	ma = cv2.add(im_yellow,im_white)
	(ret,th_ma) = cv2.threshold(ma,200,255,cv2.THRESH_BINARY)
	# 拓展 label 区域
	erode_kernel = cv2.getStructuringElement(cv2.MORPH_RECT,(80,80))
	mask = cv2.dilate(th_ma,erode_kernel)
	# frame 四周
	# (m,n) = mask.shape
	cv2.rectangle(mask, (0,10),(n,0),(255,255,255),-1)
	cv2.rectangle(mask, (0,m),(n,m-10),(255,255,255),-1)
	cv2.rectangle(mask, (0,m),(10,0),(255,255,255),-1)
	cv2.rectangle(mask, (n-10,m),(n,0),(255,255,255),-1)
	label_mask = cv2.bitwise_not(mask)
	return label_mask
# 提取线特征
def dual_canny_hough(chans,mask,imshow = 1):
	Xvs = cv2.subtract(chans[2],chans[1])
	imagevs = cv2.GaussianBlur(Xvs,(15,15),0)
	imagevscan = cv2.Canny(imagevs, 3, 40)
	imagevs = cv2.bitwise_and(imagevscan,imagevscan,mask = mask)
	lines = cv2.HoughLines(imagevs,1,np.pi/180,60) 
	if (imshow == 1):
		cv2.imshow("1 Enhanced grayscale",Xvs)
		cv2.imshow("2 Canny",imagevscan)
		cv2.imshow("3 Canny remove",imagevs)
	if lines is not None:
		return lines
# 对 canny_hough 提取出的线进行分类
def lineclass(lines):
	l = [[[0,0]]]
	l[0][0][0] = lines[0][0][0]
	l[0][0][1] = lines[0][0][1]
	for i in range(len(lines)):
		cond = 0 
		conds = 0
		for lei in l:
			if (cond == 2222):
				continue
			for line in lei:
				if (cond == 1111):
					continue					
				else:
					t_lines = lines[i][0][1]
					t_l = line[1]
					r_lines = lines[i][0][0]
					r_l = line[0]
					theta_d = abs(t_lines-t_l)
					if (theta_d<=0.25) or (2.89<=theta_d<=3.39):# 原来是 0.25
						rho_d = abs(r_lines-r_l)
						# print("rho_d",rho_d)
						if (rho_d<=40):
							line[0] = 0.5*(r_lines+r_l)
							line[1] = 0.5*(t_lines+t_l)
							# print("replace")
							cond = 1111	
						else:
							cond = 2222
					else:
						# if (cond == 2222):
						# 	print("###### should lei append ")
						# 	continue
						# else:
						conds = 3333		
			if (cond == 2222):#如果这一类的line检测完，是 append 则拓展
				lei.append([lines[i][0][0],lines[i][0][1]])
				# print("lei append")
		if (cond == 0):
			if (conds == 3333):
				# print("conds =",conds)
				l.append([[lines[i][0][0],lines[i][0][1]]])
				# print("l append")		
	return l
# 计算 Hough 变换，线参数
def lgcore_HoughLineCalculation(cos,sin,theta,rho):
	x0 = cos*rho
	y0 = sin*rho
	x1 = int(x0 + 100000*(-sin))
	y1 = int(y0 + 100000*(cos))
	x2 = int(x0 - 100000*(-sin))
	y2 = int(y0 - 100000*(cos))
	return x1,y1,x2,y2
# 寻找并确定最接近水平的线
def lgcore(l,origin,r,c,imshow = 1,linelist = [0,0,0,0,0,0,0,0,0]):
	yaw_l = [1,0,0,0,0,0,0]# 左侧线，1是最接近水平线的比较参数。2-5是 line 的原始信息，6-7是旋转的方向和角度
	yaw_r = [1,0,0,0,0,0,0]# 右侧线，1是最接近水平线的比较参数。2-5是 line 的原始信息，6-7是旋转的方向和角度
	# 垂直线使用
	# ytransl = [0.707,(0,0),(0,0),(0,0),0,0]
	# 寻找最接近水平的线
	for lei in range(len(l)):
		theta = l[lei][0][1]
		rho = l[lei][0][0]
		cos = np.cos(theta)
		sin = np.sin(theta)
		# 右侧，接近水平的线（theta 为 45-90）
		if (0<=cos<=0.707 and 0.707<sin<=1):
			if (linelist[0] == 1):
				x1,y1,x2,y2 = lgcore_HoughLineCalculation(cos,theta,rho)
				cv2.line(origin,(x1,y1),(x2,y2),(255,0,0),1)
			if (cos < yaw_r[0]):
				# 选取最接近水平的比较参数
				yaw_r[0] = cos
				# 储存 line 的原始信息
				yaw_r[1] = theta
				yaw_r[2] = rho
				yaw_r[3] = cos
				yaw_r[4] = sin
				# 选择方向和角度: right = 2
				yaw_r[5] = 2
				yaw_r[6] = 1.57 - theta
		# 左侧，rho 为 + 的接近水平的线（theta 为 90-135）		
		if (-0.707<=cos<=0 and 0.707<sin<=1):
			if (linelist[1] == 1):
				x1,y1,x2,y2 = lgcore_HoughLineCalculation(cos,theta,rho)
				cv2.line(origin,(x1,y1),(x2,y2),(255,255,255),2)
			if (0 - cos < yaw_l[0]):
				# 选取最接近水平的比较参数
				yaw_r[0] = 0 - cos
				# 储存 line 的原始信息
				yaw_r[1] = theta
				yaw_r[2] = rho
				yaw_r[3] = cos
				yaw_r[4] = sin
				# 选择方向和角度: left = 1
				yaw_r[5] = 1
				yaw_r[6] = theta - 1.57
		# 左侧，rho 为 - 的接近水平的线（theta 为 270-315）				
		if (0<=cos<=0.707 and -1<=sin<-0.707):
			if (linelist[2] == 1):
				x1,y1,x2,y2 = lgcore_HoughLineCalculation(cos,theta,rho)
				cv2.line(origin,(x1,y1),(x2,y2),(0,255,0),1)
			if (cos < yaw_l[0]):
				# 选取最接近水平的比较参数
				yaw_r[0] = cos
				# 储存 line 的原始信息
				yaw_r[1] = theta
				yaw_r[2] = rho
				yaw_r[3] = cos
				yaw_r[4] = sin
				# 选择方向和角度: left = 1
				yaw_r[5] = 1
				yaw_r[6] = theta - 4.71
		# 这些是垂向线，第一步调yaw时用不到，但是后面水平移动的时候可能需要
		# if (0.707<cos<=1 and -0.707<=sin<=0):
			# x1 = int(x0 + 100000*(-b))
			# y1 = int(y0 + 100000*(a))
			# x2 = int(x0 - 100000*(-b))
			# y2 = int(y0 - 100000*(a))
			# if (linelist[3] == 1):
			# 	cv2.line(origin,(x1,y1),(x2,y2),(255,255,255),1)
			# if (cos > ytransl[0]):
			# 	ytransl[0] = cos
			# 	x1 = rho*np.cos(theta - 4.71)
			# 	x1 = int(x1)
			# 	ytransl[1] = (x1,0)
			# 	x2 = x1+r*np.tan(theta - 4.71)
			# 	x2 = int(x2)
			# 	ytransl[2] = (x2,r)
			# 	xm = int((x1+x2)/2)
			# 	ym = int(r/2)
			# 	ytransl[3] = (xm,ym)
			# 	ytransl[4] = rho
			# 	ytransl[5] = theta
		# if (0.707<cos<=1 and 0<=sin<=0.707):
			# x1 = int(x0 + 100000*(-b))
			# y1 = int(y0 + 100000*(a))
			# x2 = int(x0 - 100000*(-b))
			# y2 = int(y0 - 100000*(a))
			# if (linelist[4] == 1):
			# 	cv2.line(origin,(x1,y1),(x2,y2),(255,255,255),1)
			# if (cos > ytransl[0]):
			# 	ytransl[0] = cos
			# 	x1 = rho*np.cos(theta)
			# 	x1 = int(x1)
			# 	ytransl[1] = (x1,0)
			# 	x2 = x1-r*np.tan(theta)
			# 	print("x2",x2)
			# 	x2 = int(x2)
			# 	ytransl[2] = (x2,r)
			# 	xm = int((x1+x2)/2)
			# 	ym = int(r/2)
			# 	ytransl[3] = (xm,ym)
			# 	ytransl[4] = rho
			# 	ytransl[5] = theta
		# if (-1<=cos<-0.707 and 0<=sin<=0.707):
			# x1 = int(x0 + 100000*(-b))
			# y1 = int(y0 + 100000*(a))
			# x2 = int(x0 - 100000*(-b))
			# y2 = int(y0 - 100000*(a))
			# if (linelist[5] == 1):
			# 	cv2.line(origin,(x1,y1),(x2,y2),(255,255,255),1)
			# if (cos > ytransl[0]):
			# 	ytransl[0] = cos
			# 	x1 = rho/np.cos(theta - 1.57)
			# 	x1 = int(x1)
			# 	ytransl[1] = (x1,0)
			# 	x2 = x1+r/np.cos(theta - 1.57)
			# 	x2 = int(x2)
			# 	ytransl[2] = (x2,r)
			# 	xm = int((x1+x2)/2)
			# 	ym = int(r/2)
			# 	ytransl[3] = (xm,ym)
			# 	ytransl[4] = rho
			# 	ytransl[5] = theta

	# 确定最接近水平的线
	yaw = []
	# print("yaw",yaw)
	if yaw_l[0] < yaw_r[0]:
		yaw = yaw_l	
	else:
		yaw = yaw_r

	return yaw
# 计算并画出选择参考线
def reference_draw(origin,m,n,yaw):
	# camera 参考线参数计算
	y_m = int(m/2)
	x_m = int(n/2)
	# panel 参考线参数计算
	circle_rho = int(n/6)
	y_increment = x_m * np.tan(yaw[6])
	rho_x_increment = circle_rho * np.cos(yaw[6])
	rho_y_increment = circle_rho * np.sin(yaw[6])
	# camera 水平线
	cv2.line(origin,(0,y_m),(n,y_m),(255,255,255),1)
	# 画出 panel 参考线
	font = cv2.FONT_HERSHEY_SIMPLEX
	text_rad = str(round(yaw[6],3))+"rad"
	deg = yaw[6] * 180 / 3.14
	text_deg = str(round(deg,1))+"deg"
	if yaw[5] == 2:#如果右转
		x_ref_1 = int(x_m - rho_x_increment)
		y_ref_1 = int(y_m + rho_y_increment)
		y_ref_2 = int(y_m - y_increment)
		cv2.line(origin,(x_ref_1,y_ref_1),(n,y_ref_2),(0,255,255),1)
		cv2.putText(origin, text_rad , (x_m - circle_rho - 150, y_m + 25), font, 1, (0, 255, 0), 2,False)
		cv2.putText(origin, text_deg , (x_m + circle_rho, y_m), font, 1, (0, 255, 0), 2,False)
	else:#如果左转
		y_ref_1 = int(y_m - y_increment)
		y_ref_2 = int(y_m + rho_y_increment)
		x_ref_2 = int(x_m + rho_x_increment)
		cv2.line(origin,(0,y_ref_1),(x_ref_2,y_ref_2),(0,255,255),1)
	# 圆形刻度盘
	cv2.circle(origin,(x_m,y_m),circle_rho,(255,255,255),1)
	# 画刻度线
	cv2.line(origin,(x_m,0),(x_m, m),(255,255,255),1)
	# 画箭头
	w = int(n/2)-5
	# ad = int(m/2)
	direction = yaw[5]
	if direction is 1:#left
		arrow = np.array([[[125,y_m-22], [125,y_m],[27,y_m],[27,y_m-81],[5,y_m-81],[38,y_m-124],[71,y_m-81],[49,y_m-81],[49,y_m-22]]], dtype = np.int32)		
	elif direction is 2:#right
		arrow = np.array([[[n-125,y_m-22], [n-125,y_m],[n-27,y_m],[n-27,y_m-81],[n-5,y_m-81],[n-38,y_m-124],[n-71,y_m-81],[n-49,y_m-81],[n-49,y_m-22]]], dtype = np.int32)		
	elif direction is 3:#up
		arrow = np.array([[[w,10], [w-33,35], [w-11,35], [w-11,75],[w+11,75],[w+11,35],[w+33,35]]], dtype = np.int32)
	else:#down
		arrow = np.array([[[w,m-10], [w-33,m-35], [w-11,m-35], [w-11,m-75],[w+11,m-75],[w+11,m-35],[w+33,m-35]]], dtype = np.int32)
	cv2.fillPoly(origin, arrow, (0,255,0))


	# if (imshow == 1):	
	cv2.imshow("3 line ",origin)	
# 定义 运动指示箭头
def arrow_define(m,n,direction):
	if direction is 1:#left
		arrow = np.array([[[10,ad], [35,ad+33],[35,ad+11],[75,ad+11],[75,ad-11],[35,ad-11],[35,ad-33]]], dtype = np.int32)
	elif direction is 2:#right
		arrow = np.array([[[n-10,ad], [n-35,ad+33],[n-35,ad+11],[n-75,ad+11],[n-75,ad-11],[n-35,ad-11],[n-35,ad-33]]], dtype = np.int32)		
	elif direction is 3:#up
		arrow = np.array([[[w,10], [w-33,35], [w-11,35], [w-11,75],[w+11,75],[w+11,35],[w+33,35]]], dtype = np.int32)
	else:
		arrow = np.array([[[w,m-10], [w-33,m-35], [w-11,m-35], [w-11,m-75],[w+11,m-75],[w+11,m-35],[w+33,m-35]]], dtype = np.int32)
	return arrow 
# 画 栅格
def gird_drawing(m,n,frame):
	x = int(n/40)
	i = 0
	while i < n:
		cv2.line(frame,(i,0),(i,m),(255,255,255),1)
		i = i + x


# def panel_rov():
# 	img = np.zeros((512,512,3), np.uint8)
# 	cv2.line(img, (0, 0), (511, 511), (255, 0, 0), 5)
# 	cv2.rectangle(img, (384, 0), (510, 128), (0, 255, 0), 5)
# 	cv2.circle(img, (447, 63), 50, (0, 0, 255),-1)
# 	cv2.ellipse(img, (256, 256), (100, 50), 90, 0,360, (0, 255, 0), -1)      
# 	pts = np.array([[10, 5], [20, 30], [70, 20], [50, 10], [50, 30], [70, 70]], np.int32)
# 	pts = pts.reshape((-1,1,2))
# 	cv2.polylines(img, [pts], False,(255, 255, 0),1)
# 　　
# 	font = cv2.FONT_HERSHEY_TRIPLEX
# cv2.putText(img, 'opencv', (10, 500), font, 4, (255, 255, 0), 1, False)　　
# 　　
# cv2.imshow('example', img)
# cv2.waitKey(0)
# cv2.destroyAllWindows()


msg = [1,1,1,0.5,0.5,0.5,3,0,0,0]
nmsg = [1,1,1,0.5,0.5,0.5,3,0,0,0]
q = 1
frameid = 1
mask_cond = 1
while(True):
	(grabbed, frame) = camera.read()
	if not grabbed:
		break

	while (frameid ==1):
		# print("frameid = ",q)
		frameid =6
		# print("c=",frameid)
		q += 1


		(chans,grayframe,m,n) = image_preprocessing(frame)
		# print("row,column",m,n)

		# #using for video
		# if mask_cond == 1 :
		# 	(mask,mask_cond) = label_remove_ll(chans)
		mask = label_remove_ll(chans,m,n,1)
		lines = dual_canny_hough(chans,mask,1)
		if lines is not None:
			# Once the line is detected, stop the ROV wait for new waypoint
			# 一旦检测到线特征，并且现在指令和最近指令一致，则停止
			if msg == nmsg:
				msg[3:6]=[0,0,0]
				print("line detected, STOP!")
				print("msg",msg)
			# remove the same lines
			l = lineclass(lines)
			print(l)
			for lines in l:
				for line in lines:
					rho = line[0]
					theta = line[1]
					cos = np.cos(theta)
					sin = np.sin(theta)
					x1,y1,x2,y2 = lgcore_HoughLineCalculation(cos,sin,theta,rho)
					cv2.line(frame,(x1,y1),(x2,y2),(255,0,0),1)

			# Calculate the rotation angle about z axis
			yaw = lgcore(l,frame,m,n,1,[0,0,0,0,0,0])
			reference_draw(frame,m,n,yaw)
			# gird_drawing(m,n,frame)
			cv2.imshow("frame",frame)


			# print("rotate {}".format(yaw_l[1]), "rad to the {}".format(yaw_l[2]))
			# if yaw_l[0] is not 1:
				# print("yaw",yaw_l[0])
		# out.write(frame)




	frameid = frameid - 1
	# print("CC = ",q)
	q += 1

	if cv2.waitKey(1) & 0xFF == ord("q"):
		break 














# def label_remove_ll(chans,imshow = 1):
# 	# 黄色 label  白色 label
# 	im_yellow = cv2.subtract(chans[1],chans[0])
# 	im_white = cv2.subtract(chans[2],chans[1])
# 	# 所有 label
# 	ma = cv2.add(im_yellow,im_white)
# 	(ret,th_ma) = cv2.threshold(ma,200,255,cv2.THRESH_BINARY)
# 	# 拓展 label 区域
# 	erode_kernel = cv2.getStructuringElement(cv2.MORPH_RECT,(80,80))
# 	mask = cv2.dilate(th_ma,erode_kernel)
# 	# frame 四周
# 	print("=====")
# 	(m,n) = mask.shape
# 	cv2.rectangle(mask, (0,10),(n,0),(255,255,255),-1)
# 	cv2.rectangle(mask, (0,m),(n,m-10),(255,255,255),-1)
# 	cv2.rectangle(mask, (0,m),(10,0),(255,255,255),-1)
# 	cv2.rectangle(mask, (n-10,m),(n,0),(255,255,255),-1)
# 	label_mask = cv2.bitwise_not(mask)
# 	mask_cond = 0
# 	if (imshow == 1):
# 		cv2.imshow("mask",label_mask)
# 	return label_mask,mask_cond