#coding=utf-8  
import cv2  
import numpy as np

# 内部调用function
def Xvs(chans,mask):
	Xvs = cv2.subtract(chans[2],chans[1])
	imagevs = cv2.GaussianBlur(Xvs,(15,15),0)
	imagevs = cv2.Canny(imagevs, 3, 40)
	imagevs1 = cv2.bitwise_and(imagevs,imagevs,mask = mask)
	lines = cv2.HoughLines(imagevs1,1,np.pi/180,100)
	return lines
def lines_filter(lines):
	# Remove similar lines detected. Calculating the mean values of theta and rho of these lines, 
	# and taking place of these lines.
	l = [[[0,0]]]
	if lines is None:
		l = [[[1,3.3]]]
		return l
	l[0][0][0] = lines[0][0][0]
	l[0][0][1] = lines[0][0][1]
	for i in range(len(lines)):
		cond = 0 
		conds = 0
		for lei in l:
			if (cond == 2222):
				continue
			for line in lei:
				if (cond == 1111):# 如果已经 replace 跳出这条line的检测循环
					continue					
				t_lines = lines[i][0][1]
				t_l = line[1]
				r_lines = lines[i][0][0]
				r_l = line[0]
				theta_d = abs(t_lines-t_l)
				if (theta_d<=0.25) or (2.89<=theta_d<=3.39):# 原来是 0.25
					rho_d = abs(r_lines-r_l)
					if (rho_d<=40):
						line[0] = 0.5*(r_lines+r_l)
						line[1] = 0.5*(t_lines+t_l)
						cond = 1111	
					else:
						cond = 2222
				else:
					conds = 3333		
			if (cond == 2222):#如果这一类的line检测完，是 append 则拓展
				lei.append([lines[i][0][0],lines[i][0][1]])
		if (cond == 0) and (conds == 3333):
			l.append([[lines[i][0][0],lines[i][0][1]]])
	return l
def lines_classify(l):
	# 对所有的线进行归类，平行线ok，对于竖向线，还要对侧面和上表面的进行细分
	# print l
	aa = [[0,0,0]]

	# 当只有一类线的时候，要根据角度范围区分竖线和水平线，但是有两类以上的时候，就一定有水平近似线【这要求 lines_filter
	# 必须能准确的分类，足够鲁棒】

	for lei in range(len(l)):
		theta = l[lei][0][1]
		if (theta >= 4.71):
			theta_jian = theta - 4.71
		elif (1.57 <= theta < 4.71):
			theta_jian = theta - 1.57
		else: #(4.71 < theta <= 6.28):
			theta_jian = 1.57 - theta 
		aa.append([lei,l[lei][0][1],theta_jian])
	# print("aa 0", aa)
	del aa[0]
	# print("aa 1", aa)

	# ************* TO DO LIST
	 # 当 lei == 1 时 怎么操作
	# if (len(aa) == 1):
	# 	# 需要判断是竖线还是水平线
	# 	if l[0][0][1]#竖线（用角度判断）
	# 	else 水平线
	# elif (len(lei) == 2):
	# 	# 找出角度最小线 近似水平


	aa.sort(key = lambda x:x[2])
	horizontal = aa[0][0]
	# theta_turn = aa[0][1]
	aa.sort(key = lambda x:x[2],reverse = True)	
	vertical = aa[0][0]
	print("horizontal",horizontal)
	# print aa
	# print("horizontal",horizontal)
	# print("vertical",vertical)
	return horizontal,vertical#,theta_turn
def lines_mean(l,horizontal):
	# 求 平均角度 用以计算旋转角度
	rho_sum = 0
	theta_sum = 0
	ss = 0
	for lei in l:
		if (ss == horizontal):
			length = len(lei)
			print("length of lei:",length)
			for line in lei:
				rho_sum += line[0]
				theta_sum += line[1]
			rho_m = rho_sum/length
			theta_m = theta_sum/length
			print("theta_m",theta_m)
			return theta_m
		else:
			continue
		ss+=1
	# theta_m = theta_turn
	# if theta_m is not None:
	# 	turn_angle = theta_m
	# 	if (0.52<theta_m<1.57):
	# 		direction = "right"
	# 	elif (1.57<theta_m<2.61):
	# 		direction = "left"
	# 	elif (0<theta_m<=0.52) or (5.76<theta_m<6.28) or (2.61<=theta_m<3.14):
	# 		direction = "up"
	# 	print("theta_m is",theta_m,",direction is",direction)
	# else:
	# 	print("############### theta_m is not found!")
	# return theta_m#,direction,turn_angle
def lines_turn(theta_m):
	turn_angle = theta_m
	direction = " NOT FOUND! "
	if (0.52<theta_m<1.57):
		direction = "right"
	elif (1.57<theta_m<2.61):
		direction = "left"
	elif (0<theta_m<=0.52) or (5.76<theta_m<6.28) or (2.61<=theta_m<3.14):
		direction = "up"
	print("theta_m is",theta_m,",direction is",direction)
	return direction,turn_angle
def lines_reference_drawing(l,horizontal,image):
	qq = 0
	for lei in l:
		print("lei is = ",lei)
		if (qq == horizontal):
			print("color choose is RED ")
			color = (0,0,255) #green
		# elif (qq == ):
		# 	print("color choose is GREEN")
		# 	color = (0,255,0)
		else:
			print("color choose is BLUE")
			color = (255,0,0)
			# print("color choose is GREEN")
			# color = (0,255,0)

		for line in lei:
			rho = line[0]
			theta= line[1]
			a = np.cos(theta)
			b = np.sin(theta)
			x0 = a*rho
			y0 = b*rho
			x1 = int(x0 + 100000*(-b))
			y1 = int(y0 + 100000*(a))
			x2 = int(x0 - 100000*(-b))
			y2 = int(y0 - 100000*(a)) 
			# print("color is ",color)
			cv2.line(image,(x1,y1),(x2,y2),color,3)
			cv2.imshow("Turning reference lines",image)
			# cv2.waitKey(0)
		qq += 1
# 还没完善的code
def lines_turn_drawing(theta_m):
	print(" WARNING!!  Not finish yet, modify the comment out code")
	print("theta_m",theta_m)
	print("rho_m",rho_m)
	a = np.cos(theta_m)
	b = np.sin(theta_m)
	x0 = a*rho_m
	y0 = b*rho_m
	x1 = int(x0 + 100000*(-b))
	y1 = int(y0 + 100000*(a))
	x2 = int(x0 - 100000*(-b))
	y2 = int(y0 - 100000*(a)) 
	# print("color is ",color)
	cv2.line(origin2,(x1,y1),(x2,y2),(255,255,255),1)
	cv2.imshow("test color drawing",origin2)
	# cv2.waitKey(0)
	return 0 

# 外部调用 function
def lineDetection(image,chans,mask):
	lines = Xvs(chans,mask)
	global direction
	global turn_angle
	if lines is not None:
		l = lines_filter(lines)
		(horizontal,vertical) = lines_classify(l)
		(theta_m) = lines_mean(l,horizontal)
		(direction,turn_angle) = lines_turn(theta_m)
		lines_reference_drawing(l,horizontal,image)
	return direction,turn_angle